module m
  use, intrinsic :: ISO_C_BINDING
  interface
    function C_FUNC(array, N) BIND(C, NAME="C_Func")
      import C_INT, C_FLOAT
      implicit none
      real(kind=C_FLOAT)               :: C_FUNC
      real(kind=C_FLOAT), dimension(*) :: array
      integer(kind=C_INT), VALUE       :: N
    end function C_FUNC
  end interface 
end module m
program p
  use m
  integer(kind=C_INT), parameter :: n = 18
  real(C_FLOAT), dimension(n)    :: tab
  real(kind=C_FLOAT)             :: y

  call random_number( tab )
  y = C_FUNC( array=tab, N=n )
  print *, "Val. retourne par la fonction : ", y
end program p
