program exemple2
  use ISO_C_BINDING
  integer(kind=C_INT)                         :: n, m
  type(C_PTR)                                 :: pointeurC
  real(kind=C_FLOAT), dimension(:,:), pointer :: p_mat
  interface
    subroutine c_alloc( ptrC, n, m ) bind(C, name="C_alloc")
      import C_PTR, C_INT
      type(C_PTR), intent(out) :: ptrC
      integer(kind=C_INT), VALUE :: n, m
    end subroutine c_alloc
    subroutine c_free( ptrC ) bind(C, name="C_free")
      import C_PTR
      type(C_PTR), VALUE :: ptrC
    end subroutine c_free
  end interface
  read *, n, m ; call c_alloc( pointeurC, n, m )
  call C_F_POINTER( CPTR=pointeurC, FPTR=p_mat, shape=(/ n, m /) )
  call random_number( p_mat )
  print *, "SOMME = ", sum( array=p_mat, dim=1 )
  call c_free( pointeurC )
end program exemple2
