module m
  implicit none
contains
  function strdup( ch_in )
    character(len=*) :: ch_in
    character(len=:), ALLOCATABLE :: strdup
    integer          :: long

    long = len_trim( ch_in )
    allocate( character(len=long) :: strdup )
    strdup = trim( ch_in )
  end function strdup
end module m
program alloca_char
  use m
  implicit none
  character(len=256) :: ch_in
  character(len=:), ALLOCATABLE :: ch_out

  read( *, '(A)' ) ch_in
  ch_out = strdup( ch_in )
  print *, len(ch_out)
  print '(A)', ch_out
  deallocate( ch_out )
end program alloca_char
