module point
  private
  type, public :: point2d
    real x, y
  contains
    PROCEDURE, PASS :: affichage => affichage_2d
  end type
contains
  subroutine affichage_2d( this, texte )
    CLASS(point2d),   intent(in) :: this
    CHARACTER(len=*), intent(in) :: texte

    print *, texte
    print *, "X = ", this%x
    print *, "Y = ", this%y
  end subroutine affichage_2d
end module point
module pointcoul
  use point
  private
  type, public, extends(point2d) :: point2d_coul
    real, dimension(3) :: compos_rvb
  end type point2d_coul
end module pointcoul
!----------------------------
program p
  use pointcoul
  type(point2d_coul) :: pcoul
  call pcoul%affichage( "Voici mes coordonnes" )
end program p
