module m
  implicit none
  integer, parameter, private :: prec=kind(1.0d0)
  type champ_vect(K,DIM1,DIM2)
    integer, kind :: K = prec
    integer, len  :: DIM1, DIM2
    ! - - - - - - - - - - - - -
    real(kind=K), dimension(DIM1,DIM2) :: champ
  end type champ_vect
  type, extends(champ_vect) :: champ_vect_label(LN)
    integer, len  :: LN
    ! - - - - - - - -
    character(len=LN) :: label
  end type champ_vect_label
end module m
program p
  use m
  implicit none
  call sp(d1=2, d2=100, texte="champ de forces lectromagntiques")
  call sp(d1=3, d2=200, texte="champ de vitesses")
contains
  subroutine sp(d1, d2, texte)
    integer,          intent(in) :: d1, d2
    character(len=*), intent(in) :: texte
    type(champ_vect_label(DIM1=d1, DIM2=d2, LN=len(texte))) :: c
    real(kind=c%K), dimension(c%DIM1, c%DIM2) :: mat

    call random_number(mat)
    c = champ_vect_label(DIM1=c%DIM1, DIM2=c%DIM2, LN=c%LN)(champ=mat, label=texte)
  end subroutine sp
end program p
