program class
  use IEEE_ARITHMETIC
  implicit none
  type(IEEE_CLASS_TYPE) :: class_type
  real                  :: x, y             
  open( unit=1, file="ieee_1_.data", form="unformatted" )
  read( unit=1 )x
  if( IEEE_SUPPORT_DATATYPE( x ) ) then
    class_type = IEEE_CLASS( x )
    if ( IEEE_SUPPORT_NAN( x ) ) then
      if ( class_type == IEEE_SIGNALING_NAN ) &
        print *,"X is a IEEE_SIGNALING_NAN"
      if ( class_type == IEEE_QUIET_NAN )     &
        print *,"X is a IEEE_QUIET_NAN"
    end if
    if ( IEEE_SUPPORT_INF( x ) ) then
      if ( class_type == IEEE_NEGATIVE_INF ) &
        print *,"X is a IEEE_NEGATIVE_INF number"
      if ( class_type == IEEE_POSITIVE_INF ) &
        print *,"X is a IEEE_POSITIVE_INF number"
    end if
    if ( IEEE_SUPPORT_DENORMAL( x ) ) then
      if ( class_type == IEEE_NEGATIVE_DENORMAL ) &
        print *,"X is a IEEE_NEGATIVE_DENORMAL number"
      if ( class_type == IEEE_POSITIVE_DENORMAL ) &
        print *,"X is a IEEE_POSITIVE_DENORMAL number"
    end if
    if ( class_type == IEEE_NEGATIVE_NORMAL ) &
      print *,"X is a IEEE_NEGATIVE_NORMAL number"
    if ( class_type == IEEE_POSITIVE_NORMAL ) &
      print *,"X is a IEEE_POSITIVE_NORMAL number"
    if ( class_type == IEEE_NEGATIVE_ZERO ) &
      print *,"X is a IEEE_NEGATIVE_ZERO number"
    if ( class_type == IEEE_POSITIVE_ZERO ) &
      print *,"X is a IEEE_POSITIVE_ZERO number"
  end if
  y = IEEE_VALUE( x, class_type ); print *,y
end program class
