module m
  use ISO_C_BINDING
  implicit none

  interface
    subroutine appel_C() bind(C)
    end subroutine appel_C
  end interface
  type(C_FUNPTR), bind(C) :: addr, addr_func

contains

  function carre(x) bind(C)
    real(C_FLOAT), VALUE, INTENT(IN) :: x
    real(C_FLOAT) :: carre

    carre = x*x
  end function carre
end module m

program p
  use m
  implicit none
  procedure(carre), pointer :: ptr_proc, fonction

  ptr_proc => carre
  addr = C_FUNLOC( carre )
  !addr = C_FUNLOC( ptr_proc )

  call appel_C

  call C_F_PROCPOINTER( addr_func, fonction )
  print *, fonction( 2.718 );
end program p
