program EXEMPLE_1
  use, intrinsic :: ISO_C_BINDING
  real(kind=C_FLOAT), dimension(:,:), allocatable, target :: mat
  integer(kind=C_INT)                                     :: n, m
  interface !------------------------------------------!
    subroutine c_func( n, m, v ) bind(C, name="fct")
      import C_INT, C_PTR
      integer(kind=C_INT), VALUE :: n, m
      type(C_PTR), VALUE :: v ! ou (*) real(kind=C_FLOAT), dimension(*) :: v
    end subroutine c_func
  end interface !--------------------------------------!
  read *, n, m ; allocate( mat(n,m) )
  call random_number( mat )
  call c_func( n, m, C_LOC(mat) ) ! ou (*) call c_func( n, m, mat )
  print *, "SOMME = ", sum( array=mat, dim=1 )
  deallocate( mat )
end program EXEMPLE_1
