module m
  use ISO_C_BINDING
  type, BIND(C) :: vecteur
    integer(kind=C_INT) :: n
    type(C_PTR)         :: pointeur_C ! Composante dynamique type "pointeur C"
  end type vecteur
  interface  ! <---------- Bloc interface de la fonction C
    subroutine moyenne(vec) BIND(c, name="C_moyenne")
      import vecteur
      type(vecteur), VALUE :: vec
    end subroutine moyenne
  end interface
end module m
program p
  use m
  type(vecteur) :: v
  real(C_FLOAT), allocatable, dimension(:), target :: tab 

  v%n = 100; allocate(tab(v%n)); call random_number(tab)
  v%pointeur_C = C_LOC(tab); call moyenne(vec=v)  ! <---Appel fonction C
  deallocate(tab)
end program p
