module m
  use ISO_C_BINDING
  implicit none
  type, BIND(C)         :: vecteur
    integer(kind=C_INT) :: n
    type(C_PTR)         :: pointeurC  ! Composante dynamique type "pointeur C"
  end type vecteur
contains
  subroutine valorisation(v) BIND(C, NAME="F_val")
    type(vecteur), VALUE                      :: v
    real(kind=C_FLOAT), dimension(:), pointer :: pointeurF

    print *, "Taille du vecteur allou en C :", v%n
    !-- Conversion du  "pointeur C" en pointeur Fortran
    call C_F_POINTER( CPTR=v%pointeurC, FPTR=pointeurF, SHAPE=[ v%n ] )
    call random_number(pointeurF)
  end subroutine valorisation
end module m
