program io
  use ISO_FORTRAN_ENV
  implicit none
  character(len=256) :: message
  integer(kind=2)    :: stat
  integer            :: i
  real               :: a, b
  namelist /var/i, a, b

  open( UNIT=1,              FILE=" io_1_.data", &
        FORM="formatted",    ACTION="read",         &
        ACCESS="sequential", ROUND="up" )
  open( UNIT=OUTPUT_UNIT, SIGN="plus" )

  do
    read( UNIT=1, FMT='(i4,1x,rd,f8.6,1x,rn,f10.1)', &
          IOSTAT=stat, IOMSG=message ) i, a, b
    if ( is_iostat_end( stat ) ) exit
    if ( stat > 0 ) then
      write( OUTPUT_UNIT, * ) message; exit
    end if
    write( OUTPUT_UNIT, NML=var )
  end do

  close( UNIT=1 )
end program io
