module m
  use ISO_FORTRAN_ENV
  type cel
    integer i
    real    r
    contains
      procedure :: ecriture
      GENERIC :: WRITE(FORMATTED) => ecriture ! <=== Generic binding.
      procedure :: affichage
  end type cel
contains
  subroutine ecriture( dtv, unit, iotype, v_list, iostat, iomsg )
    class(cel),            intent(in)    :: dtv
    integer,               intent(in)    :: unit
    character(len=*),      intent(in)    :: iotype
    integer, dimension(:), intent(in)    :: v_list
    integer,               intent(out)   :: iostat
    character(len=*),      intent(inout) :: iomsg

    write( unit, * ) dtv%i, dtv%r
  end subroutine ecriture
  subroutine affichage( this )
    class(cel), intent(in) :: this

    write( OUTPUT_UNIT, * ) this
  end subroutine affichage
end module m
program p
  use m
  type(cel) :: c=cel( r=acos(-1.), i=1756 )

  call c%affichage
end program p
