module m
  type t
    real, dimension(:),   pointer     :: p => NULL()
    character(len=:),     allocatable :: chaine
    real, dimension(:,:), allocatable :: matrice
  end type t
end module m
program construct
  use ISO_FORTRAN_ENV
  use m
  implicit none
  type(t) u
  real, dimension(:),   pointer     :: q
  real, dimension(20),  target      :: v
  real, dimension(2,3)              :: mat1
  real, dimension(:,:), allocatable :: mat2
  integer i
  call random_number(v); call random_number(mat1); q => v
  u = t( p=v, chaine="Mozart", matrice=mat1 )
  write( OUTPUT_UNIT, *) u%p, u%chaine, len(u%chaine)
  if ( allocated(u%matrice) ) call sortie        ! <== .true.
  u = t( p=q, chaine="Beethoven", matrice=mat2 )
  write( OUTPUT_UNIT, *) u%p, u%chaine, len(u%chaine)
  if ( allocated(u%matrice) ) call sortie        ! <== .false.
  u = t( p=v, chaine="Verdi", matrice=NULL() )
  write( OUTPUT_UNIT, *) u%p, u%chaine, len(u%chaine)
  if ( allocated(u%matrice) ) call sortie        ! <== .false.
  u = t( chaine="Wagner", matrice=NULL() )
  write( OUTPUT_UNIT, *) u%chaine, len(u%chaine)
  mat2 = mat1; u = t( p=q, chaine="Schubert", matrice=mat2 )
  write( OUTPUT_UNIT, *) u%p, u%chaine, len(u%chaine)
  if ( allocated(u%matrice) ) call sortie        ! <== .true.
contains
  subroutine sortie
    do i=1,size(u%matrice,1)
      write( OUTPUT_UNIT, *) u%matrice(i,:)
    end do
  end subroutine sortie
end program construct
