module m
  type t
    integer i
  end type t
  type tt
    real x
  end type tt

contains

  subroutine sp( obj )
    class(*), intent(out) :: obj ! unlimited polymorphic object

    select type( obj )
      type is(t)
        obj%i = 1756
      type is(tt)
        obj%x = acos(-1.)
      type is(real)
        obj = exp( 1. )
      type is(character(len=*))
        obj = "Pression initiale"
    end select
  end subroutine sp
end module m
program unlim
  use m 
  type(t)            obj_t
  type(tt)           obj_tt
  real               x
  character(len=100) texte

  call sp( obj_t )
  print *, obj_t
  call sp( obj_tt )
  print *, obj_tt
  call sp( x )
  print *, x
  call sp( texte )
  print *, trim(texte)
end program unlim
